<?php
// api/src/Controller/CreateMediaObjectAction.php
namespace App\Controller\CategorieDocument;

use App\Entity\CategorieDocument;
use App\Payload\ResponseApi;
use App\Repository\CategorieDocumentRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpKernel\Attribute\AsController;
use Symfony\Contracts\HttpClient\HttpClientInterface;

#[AsController]
final class CreateCategorieDocumentRequestAction extends AbstractController
{
    public function __invoke(Request $request, CategorieDocumentRepository $categorieDocumentRepository): mixed
    {
         /** @var \App\Entity\User $user */
         $user = $this->getUser();

        $categorieDocument = new CategorieDocument;
        $post_data = json_decode($request->getContent(), true);
        
        $categorieDocument->setLibelle($post_data['libelle']);
        $categorieDocument->setEstSupprimer(false);
        $categorieDocument->setCreatedAt(new \DateTimeImmutable());
        $categorieDocument->setUpdatedAt(new \DateTimeImmutable());
        $categorieDocument->setUpdatedBy($user->getId());
        $categorieDocument->setCreatedBy($user->getId());
        $categorieDocumentRepository->save($categorieDocument, true);
        
        //return new ResponseApi(true, "Thématique créée avec succès !", $categorieDocument);
        return $categorieDocument;
    }
}
