<?php
// api/src/Controller/CreateMediaObjectAction.php
namespace App\Controller\CategorieDocument;

use App\Payload\ResponseApi;
use App\Repository\CategorieDocumentRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpKernel\Attribute\AsController;
use Symfony\Contracts\HttpClient\HttpClientInterface;

#[AsController]
final class DeleteCategorieDocumentRequestAction extends AbstractController
{
    public function __invoke(Request $request, HttpClientInterface $client, CategorieDocumentRepository $categorieDocumentRepository): mixed
    {
        /** @var \App\Entity\User $user */
        $user = $this->getUser();
        
        $post_data = json_decode($request->get('id'), true);
        
        $categorieDocument = $categorieDocumentRepository->find($post_data);

        if($categorieDocument != null) {
            $categorieDocument->setEstSupprimer(true);
            $categorieDocument->setUpdatedAt(new \DateTimeImmutable());
            $categorieDocument->setUpdatedBy($user->getId());
            $categorieDocumentRepository->save($categorieDocument, true);
        }
        
        //return new ResponseApi(true, "Suppression effectuée", $categorieDocument);
        return $categorieDocument;
    }
}
