<?php
// api/src/Controller/CreateMediaObjectAction.php
namespace App\Controller\CategorieFaq;

use App\Payload\ResponseApi;
use App\Repository\CategorieFaqRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpKernel\Attribute\AsController;
use Symfony\Contracts\HttpClient\HttpClientInterface;

#[AsController]
final class UpdateCategorieFaqRequestAction extends AbstractController
{
    public function __invoke(Request $request, HttpClientInterface $client, CategorieFaqRepository $antenneRepository): mixed
    {
        /** @var \App\Entity\User $user */
        $user = $this->getUser();

        $id = json_decode($request->get('id'), true);
        $post_data = json_decode($request->getContent(), true);

        $antenne = $antenneRepository->find($id);
        
        $antenne->setLibelle($post_data['libelle']);
        $antenne->setEstSupprimer(false);
        $antenne->setCreatedAt(new \DateTimeImmutable());
        $antenne->setUpdatedAt(new \DateTimeImmutable());
        $antenne->setUpdatedBy($user->getId());
        $antenneRepository->save($antenne, true);
        
        //return new ResponseApi(true, "Thématique créée avec succès !", $antenne);
        return $antenne;
    }
}
