<?php
// api/src/Controller/CreateMediaObjectAction.php
namespace App\Controller\NewLetter;

use App\Payload\ResponseApi;
use App\Repository\NewLetterRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpKernel\Attribute\AsController;
use Symfony\Contracts\HttpClient\HttpClientInterface;

#[AsController]
final class UpdateNewLetterRequestAction extends AbstractController
{
    public function __invoke(Request $request, HttpClientInterface $client, NewLetterRepository $newLetterRepository): mixed
    {
        /** @var \App\Entity\User $user */
        $user = $this->getUser();

        $id = json_decode($request->get('id'), true);
        $post_data = json_decode($request->getContent(), true);

        $newLetter = $newLetterRepository->find($id);
        
        $newLetter->setEmail($post_data['email']);
        $newLetter->setEstVerifier($post_data['estVerifier']);
        $newLetter->setCodeForUpdating($post_data['codeForUpdating']);
        
        $newLetter->setEstSupprimer(false);
        $newLetter->setCreatedAt(new \DateTimeImmutable());
        $newLetter->setUpdatedAt(new \DateTimeImmutable());
        $newLetter->setUpdatedBy($user->getId());
        $newLetterRepository->save($newLetter, true);
        
        //return new ResponseApi(true, "Thématique créée avec succès !", $newLetter);
        return $newLetter;
    }
}
