<?php
// api/src/Controller/CreateMediaObjectAction.php
namespace App\Controller;

use App\Entity\User;
use App\Payload\ResponseApi;
use App\Repository\UserRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpKernel\Attribute\AsController;
use Symfony\Component\PasswordHasher\Hasher\UserPasswordHasherInterface;

#[AsController]
final class RequestPasswordAction extends AbstractController
{
    public function __invoke(Request $request, UserRepository $userRepository, UserPasswordHasherInterface $passwordHasher): mixed
    {
        $post_data = json_decode($request->getContent(), true);
        $user = $userRepository->findOneByEmail($post_data['email']);
        $random = random_bytes(6);
        if ($user != null) {
            $plaintPassword = $user->getPassword();
            $hashedPassword = $passwordHasher->hashPassword(
                $user,
                $random
            );
            $user->setPassword($hashedPassword);
            $user->setEstSupprimer(false);
            $userRepository->save($user, true);
            /* MAIL 
            $nomDestinataire = $user->getPrenom().' '.$user->getNom();
            $message = "Votre Nouveau Mot de passe est la suivante <br>: <strong>" . $plaintPassword . "</strong>.";
            $html = $this->renderView('mail.html.twig', [
                'message' => $message,
                'nomDestinataire' => $nomDestinataire
            ]);
            $subject = 'Réinitialisation de votre mot de passe.';

            $mailService =  new MailSenderService;
            $mailService->sendMail($html, $nomDestinataire, $user->getEmail(), $subject);
            FIN MAIL */
        }
        $user->setPassword('');
        return new ResponseApi(true, "Votre mot de passe s'est réinitialisé avec succès" , $user);
    }
}
