<?php
// api/src/Controller/CreateMediaObjectAction.php
namespace App\Controller;

use App\Entity\User;
use App\Payload\ResponseApi;
use App\Repository\UserRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpKernel\Attribute\AsController;
use Symfony\Component\PasswordHasher\Hasher\UserPasswordHasherInterface;

#[AsController]
final class ResetPasswordForUserAction extends AbstractController
{
    public function __invoke(Request $request, UserRepository $userRepository, UserPasswordHasherInterface $passwordHasher): mixed
    {
        $post_data = json_decode($request->getContent(), true);

        $password = $post_data['password'];
        $id = $post_data['id'];

        $user = $userRepository->find($id);
        $rep = false;
        $message = "";
        if ($user != null) {
            $hashedPassword = $passwordHasher->hashPassword(
                $user,
                $password
            );
            $user->setPassword($hashedPassword);
            $user->setEstSupprimer(false);
            $userRepository->save($user, true);
            $rep = true;
            $message = "Mot de passe est changé avec succès";
        } else {
            $rep = false;
            $message = "Erreur de changement du mot de passe";
        }
        $user->setPassword('');
        return new ResponseApi($rep, $message , $user);
    }
}
