<?php
// api/src/Controller/CreateMediaObjectAction.php
namespace App\Controller\Tag;

use App\Payload\ResponseApi;
use App\Repository\TagRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpKernel\Attribute\AsController;
use Symfony\Contracts\HttpClient\HttpClientInterface;

#[AsController]
final class UpdateTagRequestAction extends AbstractController
{
    public function __invoke(Request $request, HttpClientInterface $client, TagRepository $tagRepository): mixed
    {
        /** @var \App\Entity\User $user */
        $user = $this->getUser();

        $id = json_decode($request->get('id'), true);
        $post_data = json_decode($request->getContent(), true);

        $tag = $tagRepository->find($id);
        
        $tag->setLibelle($post_data['libelle']);
        $tag->setEstSupprimer(false);
        $tag->setCreatedAt(new \DateTimeImmutable());
        $tag->setUpdatedAt(new \DateTimeImmutable());
        $tag->setUpdatedBy($user->getId());
        $tagRepository->save($tag, true);
        
        //return new ResponseApi(true, "Thématique créée avec succès !", $tag);
        return $tag;
    }
}
