<?php

namespace App\EntityListener;

use App\Entity\User;
use App\Repository\UserRepository;
use Doctrine\ORM\Event\LifecycleEventArgs;
use Doctrine\Bundle\DoctrineBundle\Attribute\AsEntityListener;
use Doctrine\ORM\Events;

#[AsEntityListener(event: Events::preUpdate, method: 'preUpdate', entity: User::class)]
#[AsEntityListener(event: Events::prePersist, method: 'prePersist', entity: User::class)]
class UserEntityListener
{
    private $userRepository;

    public function __construct(UserRepository $userRepository)
    {
        $this->userRepository = $userRepository;
    }

    public function prePersist(User $user, LifecycleEventArgs $event)
    {
        $user->setUpdatedAt(new \DateTimeImmutable());
        $user->setCreatedAt(new \DateTimeImmutable());
    }

    public function preUpdate(User $user, LifecycleEventArgs $event)
    {
        $user->setUpdatedAt(new \DateTimeImmutable());
    }

}
