<?php
# api/src/Entity/User.php
namespace App\Payload;
use ApiPlatform\Metadata\ApiResource;
use ApiPlatform\Metadata\Post;
use App\Controller\RequestPasswordAction;
use App\Controller\SignupAction;

#[ApiResource(
    routePrefix: '/white-api',
    operations: [
        new Post(uriTemplate: '/signup', 
            controller: SignupAction::class,
            input: Signup::class),
        new Post(uriTemplate: '/request-password', 
            controller: RequestPasswordAction::class,
            input: RequestPassword::class
        ),
    ],
    formats: [
        //  'jsonld' => ['application/ld+json'],
        'json' =>    ['application/json'],
        'xml' =>     ['application/xml', 'text/xml'],
    ],
    paginationEnabled: false
)]
class WhiteApi { 

    
}
